#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add_include") {&add_include;}
if ($q->param('fct') eq "preview") {&preview_include;}
if ($q->param('fct') eq "edit") {&edit_include;}
if ($q->param('fct') eq "save_include") {&save_include;}
if ($q->param('fct') eq "delete") {&delete_include;}



##################################################################################

sub delete_include
{

$iname = $q->param('incl');
$ifilename = lc("incl_" . $iname . ".html");
unlink ("$data_dir/$ifilename");


$headi_display = acs::get_heading_box("$web_url/ic_tmplincl.gif", "Template Include Deleted", qq[
<a href="$admin_url/admin17.cgi">Click Here to Continue</a>
]);


print <<END_OF_DL;

<html>
<head>
<title>Includes</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$headi_display
</body>
</html>

END_OF_DL

}




sub save_include
{

if ($q->param('iname') eq ""){acs::problem_popup("You have to provide a name for the include.");}
if ($q->param('ihtml') eq ""){acs::problem_popup("The include requires at some HTML code or at least some text.");}

$iname = $q->param('iname');

for ($ms = 0; $ms < length($iname); $ms++) 
	{
	$oneletter = substr($iname, $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
		acs::problem_popup ("The template include name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	}

### CHECK FOR DUPLICATES

$ifilename = "incl_$iname.html";

if ($q->param('orign') ne $iname)
	{
	$ifilename = lc("incl_" . $iname . ".html");
	if ((-e "$data_dir/$ifilename") > 0){acs::problem_popup("The include name you are trying to use already exists.");}
	
	$origfn = lc("incl_" . $q->param('orign') . ".html");
	unlink ("$data_dir/$origfn");
	}

### SAVE INCLUDE

#print "===> $data_dir/$ifilename ";

open (INCL, "> $data_dir/$ifilename");
	print INCL $q->param('ihtml');
close (INCL);



$headi_display = acs::get_heading_box("$web_url/ic_tmplincl.gif", "Template Include Saved", qq[
<a href="$admin_url/admin17.cgi">Click Here to Continue</a>
]);


print <<END_OFA;

<html>
<head>
<title>Includes</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$headi_display

</body>
</html>

END_OFA

}





sub edit_include
{

$iname = $q->param('incl');
$ifilename = "incl_" . $iname . ".html";
$ihtml = acs::get_file_contents("$data_dir/$ifilename");


$headi_display = acs::get_heading_box("$web_url/ic_tmplincl.gif", "Edit Template Include", qq[
<a href="$admin_url/admin17.cgi">Go Back</a>
]);


$helpb = acs::quick_help("Quick Template Help",qq[

<p><strong>The following global variables are available to Template Includes and all other
templates except link style templates: </strong></p>

<blockquote>
  <p><strong>!build_url! </strong><br>
  This is always replaced by the URL path to the 'html' directory, or the directory where
  all generated HTML files are stored. <br>
  <br>
  <strong>!!add_url_link!! </strong><br>
  This is always replaced by a URL path to the 'Add URL' form or the cgi script that
  displays the 'Add URL' form. <br>
  <br>
  <strong>!!add_premium_url_link!! </strong><br>
  This is always replaced by a URL path to the 'Premium Link Add URL' form or the cgi script
  that displays the 'Premium Link Add URL' form. <br>
  <br>
  <strong>!!whatsnew!! </strong><br>
  This is always replaced by a URL path to the page that indicates the latest link additions
  to your directory. <br>
  <br>
  <strong>!!tophits!! </strong><br>
  This is always replaced by a URL path to the page that indicates most popular links inside
  your directory. <br>
  <br>
  <strong>!!modify_link_url!! </strong><br>
  This is always replaced by a URL path to the modify CGI script that enable users to modify
  their links. </p>
  <p><strong>!!register!! </strong><br>
  This is replaced by a link to the registration form that visitors complete to register an
  account. Note that you have to use the user registration system. </p>
  <p><strong>!!rgs_loginl!! </strong><br>
  This is replaced by a link to the login page where visitors log into their accounts. (To
  add links or view/modify them) <br>
  &nbsp; <br>
  <strong>!!tseeksearch!! </strong><br>
  This is always replaced by the URL path to the search CGI scripts. The search CGI scripts
  are the scripts that searches through your Directory when a visitor invokes a search. </p>
</blockquote>

<hr size="1" color="#DDDDDD">

<p><strong>You can use the following HTML code to create a Search Box inside any PowerSeek
Template Include:</strong></p>

<blockquote>
  <p>&lt;form method=&quot;POST&quot; action=&quot;!!tseeksearch!!&quot;&gt;<br>
  &lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;20&quot;&gt;<br>
  &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
  &lt;/form&gt;</p>
</blockquote>

<hr size="1" color="#DDDDDD">

<p><strong>Note that when you make use of images </strong>in the HTML code of templates
that you must use a URL link to indicate their locations. <br>
<br>
<strong>For example: </strong></p>

<blockquote>
  <p><strong>&lt;img src=&quot;someimage.gif&quot;&gt; will not work. </strong><br>
  &nbsp; <br>
  <strong>You have to indicate the entire URL where someimage.gif is located. For example: </strong><br>
  &nbsp;&nbsp;&nbsp;&nbsp; <br>
  <strong>&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong><br>
  &nbsp;&nbsp;&nbsp; <br>
  The <strong>&lt;img </strong>is an HTML tag indicating that you want to insert an image in
  the HTML page. The <strong>src= </strong>part indicates that you want to specify the
  location of the image to be inserted. Some web editors will support inserting images from
  a web url and some won't. If your web editor does not support this, insert the image into
  the HTML page like usual and when finished edit the source of the HTML code and manually
  insert the URL path's to the images. Ensure that the images are on the server for the URL
  path's you specify. </p>
  <blockquote>
    <p><strong>Example, editing the HTML source code: </strong></p>
  </blockquote>
  <blockquote>
    <p><strong>Replace &lt;img src=&quot;someimage.gif&quot;&gt; with <br>
    &lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong></p>
  </blockquote>
</blockquote>



]);  



print <<END_OF_EDI;
<html>
<head>
<title>Includes</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

<form method="POST" action="$admin_url/admin17.cgi">

$headi_display


<table border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(221,221,221)">
    <tr>
      <td width="100%" height="30" colspan="2" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Edit Template Include </strong></td>
    </tr>
    <tr>
      <td width="29%" height="38" valign="top" class="normaltext"><img src="$web_url/first.gif"> <strong>Name: </strong></td>
      <td width="72%" height="38" class="normaltext"><input name="iname" type="text" value="$iname" size="31"  style="width:100%"> 
      <br>
      Only alphabetical or numerical characters allowed. Underscores also allowed. Once the
      include has been created you may reference it in any template by providing the name
      surrounded by %%incl_ and %% characters. For example, lets say your template include name
      is <strong>header. </strong>You will then be able to use %%incl_ <strong>header </strong>%%
      in any template to include the HTML code of the include called <strong>header </strong>. </td>
    </tr>
    <tr>
      <td width="29%" height="38" valign="top" class="normaltext"><img src="$web_url/first.gif"> <strong>Template
      Include HTML Code: </strong></td>
      <td width="72%" height="38" class="normaltext"><textarea rows="16" name="ihtml" cols="56"  style="width:100%">$ihtml</textarea> </td>
    </tr>
    <tr>
      <td width="29%" height="38" valign="top" class="normaltext"></td>
      <td width="72%" height="38" class="normaltext"><input type="submit" value="     Save     " name="add">
        <input type="hidden" name="fct" value="save_include">
        <input type="hidden" name="orign"
  value="$iname"></td>
    </tr>
  </table>



<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="147%"></td>
    </tr>
  </table>
  
  $helpb
  
</form>


</body>
</html>

END_OF_EDI




}



sub preview_include
{

$iname = $q->param('incl');
$ifilename = "incl_" . $iname . ".html";
$incl_data = acs::get_file_contents("$data_dir/$ifilename");

$incl_data = &fill_vars($incl_data);

print $incl_data;
}






sub add_include
{

if ($q->param('iname') eq ""){acs::problem_popup("You have to provide a name for the include.");}
if ($q->param('ihtml') eq ""){acs::problem_popup("The include requires HTML code or at least some text.");}

$iname = $q->param('iname');


for ($ms = 0; $ms < length($iname); $ms++) 
	{
	$oneletter = substr($iname, $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
		acs::problem_popup ("The template include name you specified contain invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	}



$ifilename = lc("incl_" . $iname . ".html");

### CHECK FOR DUPLICATES

if ((-e "$data_dir/$ifilename") > 0){acs::problem_popup("The include name you are trying to use already exists.");}

open (INCL, "> $data_dir/$ifilename");
	print INCL $q->param('ihtml');
close (INCL);




$headi_display = acs::get_heading_box("$web_url/ic_tmplincl.gif", "Template Include Created", qq[
<a href="$admin_url/admin17.cgi">Click here to continue</a>
]);




print <<END_OFA;

<html>
<head>
<title>Includes</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$headi_display
</body>
</html>

END_OFA

}





sub start
{

### GET INCLUDES

$incl_listings_top = <<END_OF_ILT;     
<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="34%" height="28" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Include
    Name </strong></td>
    <td width="33%" height="28" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Include
    text to use in templates </strong></td>
    <td width="11%" height="28" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Preview
    </strong></td>
    <td width="11%" height="28" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Edit
    </strong></td>
    <td width="11%" height="28" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Delete
    </strong></td>
  </tr>
END_OF_ILT

################

opendir(DIR,"$data_dir");
@files = readdir(DIR);

@files = sort(@files);

foreach $filename (@files)
	{
	if ((substr($filename, 0, 5) eq "incl_") and (substr($filename, length($filename) - 5, 5) eq ".html"))
		{
		$incl = $filename;
		$incl =~ s/^incl_//g;
		$incl =~ s/\.html//g;
		
$incl_listings = $incl_listings . <<END_OF_IL;
 <tr>
    <td width="34%" height="28" valign="top" class="normaltext">$incl </td>
    <td width="33%" height="28" valign="top" class="normaltext">%%incl_$incl%% </td>
    <td width="11%" height="28" align="center" valign="top" class="normaltext"><a
    href="$admin_url/admin17.cgi?fct=preview&amp;incl=$incl" target="_blank">Preview </a></td>
    <td width="11%" height="28" align="center" valign="top" class="normaltext"><a
    href="$admin_url/admin17.cgi?fct=edit&amp;incl=$incl">Edit </a></td>
    <td width="11%" height="28" align="center" valign="top" class="normaltext"><a
    href="$admin_url/admin17.cgi?fct=delete&amp;incl=$incl">Delete </a></td>
  </tr>
END_OF_IL
		}
	}


if ($incl_listings ne "")
	{
	$template_incl = qq[$incl_listings_top $incl_listings </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="147%"></td>
  </tr>
</table>
</center>
	
	];
	}
	else
	{
	$template_incl = "<font face=\"Verdana\" size=\"2\">No template includes available yet.</font>";
	}



$headi_display = acs::get_heading_box("$web_url/ic_tmplincl.gif", "Template Includes", qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="99%" class="normaltext">Template includes are pieces of HTML code that can be included in any
    template. These pieces of HTML code could be headers, footers or menu bars. It almost
    works like SSI's (server side includes) or Java Script Includes. Note that the template
    includes will only work in the PowerSeek templates. It will work in any template used by
    PowerSeek. </td>
    <td width="1%" valign="top"><a href="$admin_url/help.cgi?fct=template_includes" target="_blank"><img
    src="$web_url/bhelps.gif" border="0"></a></td>
  </tr>
</table>
]);



$helpb = acs::quick_help("Quick Template Help",qq[


<p><strong>The following global variables are available to Template Includes and all other
templates except link style templates: </strong></p>

<blockquote>
  <p><strong>!build_url! </strong><br>
  This is always replaced by the URL path to the 'html' directory, or the directory where
  all generated HTML files are stored. <br>
  <br>
  <strong>!!add_url_link!! </strong><br>
  This is always replaced by a URL path to the 'Add URL' form or the cgi script that
  displays the 'Add URL' form. <br>
  <br>
  <strong>!!add_premium_url_link!! </strong><br>
  This is always replaced by a URL path to the 'Premium Link Add URL' form or the cgi script
  that displays the 'Premium Link Add URL' form. <br>
  <br>
  <strong>!!whatsnew!! </strong><br>
  This is always replaced by a URL path to the page that indicates the latest link additions
  to your directory. <br>
  <br>
  <strong>!!tophits!! </strong><br>
  This is always replaced by a URL path to the page that indicates most popular links inside
  your directory. <br>
  <br>
  <strong>!!modify_link_url!! </strong><br>
  This is always replaced by a URL path to the modify CGI script that enable users to modify
  their links. </p>
  <p><strong>!!register!! </strong><br>
  This is replaced by a link to the registration form that visitors complete to register an
  account. Note that you have to use the user registration system. </p>
  <p><strong>!!rgs_loginl!! </strong><br>
  This is replaced by a link to the login page where visitors log into their accounts. (To
  add links or view/modify them) <br>
  &nbsp; <br>
  <strong>!!tseeksearch!! </strong><br>
  This is always replaced by the URL path to the search CGI scripts. The search CGI scripts
  are the scripts that searches through your Directory when a visitor invokes a search. </p>
</blockquote>

<hr size="1" color="#DDDDDD">

<p><strong>You can use the following HTML code to create a Search Box inside any PowerSeek
Template Include:</strong></p>

<blockquote>
  <p>&lt;form method=&quot;POST&quot; action=&quot;!!tseeksearch!!&quot;&gt;<br>
  &lt;input type=&quot;text&quot; name=&quot;keywords&quot; size=&quot;20&quot;&gt;<br>
  &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
  &lt;/form&gt;</p>
</blockquote>

<hr size="1" color="#DDDDDD">

<p><strong>Note that when you make use of images </strong>in the HTML code of templates
that you must use a URL link to indicate their locations. <br>
<br>
<strong>For example: </strong></p>

<blockquote>
  <p><strong>&lt;img src=&quot;someimage.gif&quot;&gt; will not work. </strong><br>
  &nbsp; <br>
  <strong>You have to indicate the entire URL where someimage.gif is located. For example: </strong><br>
  &nbsp;&nbsp;&nbsp;&nbsp; <br>
  <strong>&lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong><br>
  &nbsp;&nbsp;&nbsp; <br>
  The <strong>&lt;img </strong>is an HTML tag indicating that you want to insert an image in
  the HTML page. The <strong>src= </strong>part indicates that you want to specify the
  location of the image to be inserted. Some web editors will support inserting images from
  a web url and some won't. If your web editor does not support this, insert the image into
  the HTML page like usual and when finished edit the source of the HTML code and manually
  insert the URL path's to the images. Ensure that the images are on the server for the URL
  path's you specify. </p>
  <blockquote>
    <p><strong>Example, editing the HTML source code: </strong></p>
  </blockquote>
  <blockquote>
    <p><strong>Replace &lt;img src=&quot;someimage.gif&quot;&gt; with <br>
    &lt;img src=&quot;http://www.yourdomain.com/someimage.gif&quot;&gt; </strong></p>
  </blockquote>
</blockquote>


]);  


print <<END_OF_INCLUDES;

<html>

<head>
<title>Includes</title>
</head>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<body>

<form method="POST" action="$admin_url/admin17.cgi">
  <input type="hidden" name="fct" value="add_include">


$headi_display

$template_incl


<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(221,221,221)">
  <tr>
    <td width="100%" height="30" colspan="2" valign="top" background="$web_url/bar6.gif"
    class="normaltext"><strong>Add a New Template Include: </strong></td>
  </tr>
  <tr>
    <td width="29%" height="38" valign="top" class="normaltext"><strong>Name: </strong></td>
    <td width="72%" height="38" class="normaltext"><input type="text" name="iname" size="31"
    style="width:100%"> <br>
    Only alphabetical or numerical characters allowed. Underscores also allowed. Once the
    include has been created you may reference it in any template by providing the name
    surrounded by&nbsp; %%_incl and %%. For example, lets say your template include name is <strong>header.
    </strong>You will then be able to use %%incl_ <strong>header </strong>%% in any template
    to include the HTML code of the include called <strong>header </strong>. </td>
  </tr>
  <tr>
    <td width="29%" height="38" valign="top" class="normaltext"><strong>Template Include HTML
    Code: </strong></td>
    <td width="72%" height="38" class="normaltext"><textarea rows="16" name="ihtml" cols="56"
    style="width:100%"></textarea> </td>
  </tr>
  <tr>
    <td width="29%" height="38" valign="top" class="normaltext"></td>
    <td width="72%" height="38" class="normaltext"><input type="submit"
    value="Add New Template Include" name="add"> </td>
  </tr>
</table>




<table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="147%"></td>
    </tr>
  </table>

$helpb

</form>

</body>
</html>

END_OF_INCLUDES



}






sub fill_vars
{

my ($filledvar) = @_;

$filledvar =~ s/!!scripts_url!!/$script_url/g;
$filledvar =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
$filledvar =~ s/!build_url!/$web_url/g;
$filledvar =~ s/!!build_url!!/$web_url/g;

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);
$statsetting = $conflines[29];
chop($statsetting);


####
if ($statsetting =~ /dyn_stat=Dynamic/)
	{
	$filledvar =~ s/!!whatsnew!!/$script_url\/dirs\.cgi?newpop=new/g;
	$filledvar =~ s/!!tophits!!/$script_url\/dirs\.cgi?newpop=pop/g;
	}
	else
	{
	$filledvar =~ s/!!whatsnew!!/$web_url\/new\//g;
	$filledvar =~ s/!!tophits!!/$web_url\/pop\//g;
	}

$filledvar =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
$filledvar =~ s/!!add_url_link!!/$script_url\/addurl\.cgi/g;
$filledvar =~ s/!!add_premium_url_link!!/$script_url\/addurl\.cgi?p=1/g;

return ($filledvar);
}




####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

